
// Set the page title from the URL parameter
var argv = new Array();
var query = window.location.search.substring(1);
var parms = query.split('&');
for (var i=0; i<parms.length; i++) {
  var pos = parms[i].indexOf('=');
  if (pos > 0) {
    var key = parms[i].substring(0,pos);
    var val = parms[i].substring(pos+1);
    argv[key] = val;
  }
}

// All of the Animator objects on the page
var animators = new Array();
function animator_loop(index) {
  a = animators[index];
  moreToCome = a.incrementShow();
  if (moreToCome) {
    // Call back into this function for this animator in a while
    a.timeout = setTimeout('animator_loop('+index+');', a.interval);
  }
}

function Animator(imageid) {
  if (document.getElementById) {
    this.image = document.getElementById(imageid);
  } else if (document.all) {
    this.image = document.all[imageid];
  }
  this.images = new Array();
  this.times = new Array();
  this.interval = 30;
  this.prefix = '';
  this.current = 0; // Currently displayed index
  this.tickCount = 0;
  this.loop = true;
  
  // Add this animator object to the overall list
  this.index = animators.length;
  animators[this.index] = this;
  
  this.show = function() {
    if (!this.image) return;
    currentImage = this.images[this.current];
    if (!currentImage) return;
    this.image.src = currentImage.src;
  }
  this.incrementShow = function() {
    if (this.running) {
      this.tickCount++;
      if (this.tickCount > this.times[this.current]) {
        this.tickCount = 0;                    
        this.current = this.current + 1;
        if (this.current >= this.images.length) {
          if (this.loop) {
            this.current = this.current % this.images.length;
            this.show();
          } else {
            this.running = false;
            return false;
          }
              } else {
          this.show();
        }
      } 
      return true;
    } else {
      return false;
    }
  }
  this.add = function(url) {
    var l = this.images.length;
    this.images.length++;
    this.times.length++;                    
    this.images[l] = new Image();
    this.images[l].src = this.prefix + url + ".png";
  }
  this.setTime = function(which, time) {
    this.times[which] = time*10; // number of ticks
  }
  this.reset = function() {
    this.current = 0;
    this.show();
  }
  this.run = function() {
    if (!this.running) {
      this.timeout = setTimeout('animator_loop('+this.index+');', this.interval);
    }
    if (this.current >= this.images.length) {
      this.reset();
    }
    this.running = true;
  }
  this.stop = function() {
    if (this.running) {
      clearTimeout(this.timeout);
    }
    this.running = false;
  }
}

function animate() {
  animator = new Animator("animatedImage");
  animator.prefix="photos/scaled1000x1000/" + argv["prefix"];
  // Get the list of frames from the arguments
  if (argv["list"]) {
    var pix = argv["list"].split('+');
    for (var ii=0; ii<pix.length; ii++) {
      animator.add(pix[ii]);
    }
  }
  if (argv["tl"]) {
    var times = argv["tl"].split('+');
    for (var ii=0; ii<times.length; ii++) {
      animator.setTime(ii, times[ii]);
    }                              
  }
  if (argv["loop"]) {
    document.panel.loop.checked = (argv["loop"] == "y");
  } else {
    document.panel.loop.checked = true;
  }
  animator.loop = document.panel.loop.checked;
  animator.run();
}
function setParams() {
  document.title = unescape(argv["title"]);
  var node;
  var back;                                  
  if (document.getElementById) {
    node = document.getElementById("pagename");
    back = document.getElementById("backlink");
  } else if (document.all) {
    node = document.all["pagename"];
    back = document.all["backlink"];
  }
  node = node.childNodes[0];
  if (node) {
    var newNode = document.createTextNode(unescape(argv["title"]).toUpperCase());
    var parent = node.parentNode;
    parent.replaceChild(newNode, node);
  }
  if (back) {
    back.href = argv["back"]+".html";
  }
}
